/*
	La version toujours plus dveloppe de l'applet "maison"
	Possibilit de slectionner des figures et surtout de modifier
	leur taille avec la souris.

	(C) J. Ferber - Octobre 2000
*/
package maison;

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;
import java.util.Vector;


/** La class Figure est  la racine d'hritage des figures **/
abstract class Figure extends Object implements Cloneable {

	final public int HANDLE_SIZE=8;

	DrawingPane environment;

	int x=0; int y=0;
	int couleur;
        Figure(){}
        abstract Figure cloneFig(int x0, int y0, int x1, int y1, int coul);

        abstract void dessiner(Graphics g); // la methode abstraite de dessin

	boolean selected=false;
	void setSelected(boolean b){
		selected = b;
	}


	void setPos(int x1, int y1){
		x = x1; y = y1;
	}

	void setColor(int coul){ couleur = coul;}

 	abstract void drawBuild(Graphics g, int ox, int oy, int nx, int ny);

    abstract void translate(Graphics g, int dx, int dy);

    abstract boolean contains(Point p);

	public void doReSelect(int _x, int _y){}

	public void doDrag(Graphics g, int _x, int _y){
			translate(g, _x, _y);
	}

	public void activate(DrawingPane env){
	}

/** pour changer les couleurs
	*/
	Color getColor(int c) {
  		switch(c) {
  			case 0: return(Color.black);
  			case 1: return(Color.blue);
  			case 2: return(Color.cyan);
  			case 3: return(Color.darkGray);
  			case 4: return(Color.red);
  			case 5: return(Color.green);
  			case 6: return(Color.lightGray);
  			case 7: return(Color.magenta);
  			case 8: return(Color.orange);
  			case 9: return(Color.gray);
  			case 10: return(Color.pink);
  			case 11: return(Color.yellow);
  			default : return(Color.black);
		}
  	}
}